'                                 BARIC.BAS

'     versione 1.2 per QBASIC                                     rev. 11.93

DECLARE SUB Baricentro (Fi$, Fo$)

CONST nMaxPun = 200

CLS
PRINT "                  BARIC - vers. 1.2                 rev. 11.93"
PRINT : PRINT
PRINT "        Le ipotesi  di calcolo  e le  modalit  operative  del  programma"
PRINT "        BARIC  sono riportate nella terza parte,  capitolo 2,  del libro:"
PRINT "        A.Ghersi, Edifici antisismici con struttura intelaiate in cemento"
PRINT "        armato, CUEN, Napoli, 1986-1991."
PRINT
PRINT "        La presente versione legge i dati da un file anzich da linee del"
PRINT "        programma."
PRINT
PRINT
PRINT "        Nome del file che contiene i dati ";
INPUT Fi$
PRINT
PRINT "        Unit di uscita ?"
PRINT "        CON=schermo, PRN=stampante, oppure nome di un file"
PRINT "        ";
INPUT Fo$
Fo$ = UCASE$(Fo$)
IF Fo$ = "CON" THEN Fo$ = ""
PRINT
CALL Baricentro(Fi$, Fo$)
LOCATE 23, 1
PRINT "Elaborazione terminata"
END

SUB Baricentro (Fi$, Fo$)

   ' - - - - -  dimensionamento variabili con indice
   DIM X(nMaxPun), Y(nMaxPun)
   ' - - - - -  apertura unit di ingresso e uscita
   Fi = FREEFILE
   OPEN Fi$ FOR INPUT AS #Fi
   IF Fo$ <> "" THEN
      Fo = FREEFILE
      OPEN Fo$ FOR OUTPUT AS #Fo
      CLOSE #Fo
   END IF
   SCREEN 2
   CLS
   DO WHILE NOT EOF(Fi)
      ' - - - - -  lettura dati
      INPUT #Fi, N
      IF N = 0 THEN EXIT DO
      FOR I = 1 TO N
         INPUT #Fi, X(I), Y(I)
      NEXT I
      ' - - - - -  calcolo
      A = 0
      S1 = 0
      S2 = 0
      Ix = 0
      Iy = 0
      FOR I = 1 TO N
         GOSUB Calcola
         A = A + A0
         S1 = S1 + A0 * X0
         S2 = S2 + A0 * Y0
         Ix = Ix + Ix0
         Iy = Iy + Iy0
      NEXT I
      X = S1 / A
      Y = S2 / A
      Ix = Ix - A * Y ^ 2
      Iy = Iy - A * X ^ 2
      Ro = SQR((Ix + Iy) / A)
      GOSUB Visualizza
      LOCATE 1, 1
      PRINT USING "Area =####.## m2"; A
      PRINT "Coordinate del baricentro:";
      PRINT USING "    x =###.## m    y =###.## m"; X; Y
      PRINT USING "Raggio d'inerzia:             r =###.## m"; Ro
      LOCATE 5, 1: PRINT "premi un tasto per continuare";
      ' - - - - -  stampa risultati
      ' IF FO$ = "LPT1" THEN LCOPY     '*  aggingere richiamo a mie procedure
      IF Fo$ <> "" THEN
         OPEN Fo$ FOR APPEND AS #Fo
         PRINT #Fo, : PRINT #Fo,
         PRINT #Fo, USING "Area =####.## m2"; A
         PRINT #Fo, "Coordinate del baricentro:";
         PRINT #Fo, USING "     x =###.##      y =###.## m"; X; Y
         PRINT #Fo, USING "Raggio d'inerzia:             r =###.## m"; Ro
         CLOSE #Fo
      END IF
      ' - - - - -  aspetta che sia premuto un tasto per continuare
      DO
         U$ = INKEY$
      LOOP UNTIL U$ <> ""
   LOOP
   CLOSE #Fi
   VIEW
   CLS
   SCREEN 0
EXIT SUB

Calcola:
   ' ---------  calcolo area e baricentro del triangolo
   I1 = I MOD N + 1
   A0 = (X(I) * Y(I1) - X(I1) * Y(I)) / 2
   X0 = (X(I) + X(I1)) / 3
   Y0 = (Y(I) + Y(I1)) / 3
   Ix0 = A0 * (Y(I) ^ 2 + Y(I) * Y(I1) + Y(I1) ^ 2) / 6
   Iy0 = A0 * (X(I) ^ 2 + X(I) * X(I1) + X(I1) ^ 2) / 6
RETURN

Visualizza:
   ' ---------  visualizzazione figura e baricentro
   VIEW (0, 0)-(639, 199): CLS
   VIEW (0, 56)-(639, 199)
   X1 = X(1): X2 = X(1): Y1 = Y(1): Y2 = Y(1)
   FOR I = 2 TO N
      IF X(I) < X1 THEN X1 = X(I)
      IF X(I) > X2 THEN X2 = X(I)
      IF Y(I) < Y1 THEN Y1 = Y(I)
      IF Y(I) > Y2 THEN Y2 = Y(I)
   NEXT I
   GOSUB Scala
   WINDOW (X1, Y1)-(X2, Y2)
   PSET (X(N), Y(N)), 2
   FOR I = 1 TO N
      LINE -(X(I), Y(I))
   NEXT I
   LINE (X - .5, Y)-(X + .5, Y)
   LINE (X, Y - .5)-(X, Y + .5)
   LOCATE 1, 1
RETURN

Scala:
   ' ---------  definizione scala per rappresentazione monometrica
   ' N.B. DimOr e DimVer sono le dimensioni orizzontali e verticali dell'area
   '      grafica,  che possono essere modificate  dall'utente  per adeguarle
   '      alle caratteristiche del proprio schermo
   DimOr = .19
   DimVer = .125
   FX = DimOr
   FY = DimVer * 18 / 25
   SC = (X2 - X1) / FX
   IF SC < (Y2 - Y1) / FY THEN SC = (Y2 - Y1) / FY
   LX = FX * SC
   LY = FY * SC
   XC = (X1 + X2) / 2
   YC = (Y1 + Y2) / 2
   X1 = XC - LX / 2
   X2 = XC + LX / 2
   Y1 = YC - LY / 2
   Y2 = YC + LY / 2
RETURN

END SUB

