'                                  GRAFICA.BAS
'
'          Procedure per l'individuazione della scheda grafica
'          e per la copia di grafici su stampante o file
'
'    versione 1.2                                            rev. 10.90

DIM SHARED Scheda1
CONST VGA = 12, MCGA = 11, EGA = 8, HERC = 3, CGA = 2, MONO = 0

ModGrafErr:              ' individuazione della modalita` grafica
SELECT CASE Scheda1
   CASE VGA
      Scheda1 = MCGA
   CASE MCGA
      Scheda1 = EGA
   CASE EGA
      Scheda1 = CGA
   CASE CGA
      Scheda1 = HERC
   CASE ELSE
      Scheda1 = MONO     ' scheda grafica non presente o non riconosciuta
END SELECT
RESUME

' ================================ FCOPY =======================================
'
'   Effettua la copia dello schermo, in modalita` grafica, su un file
'
'   Variabili di ingresso:
'      SCR       modalita` grafica corrente; sono previste:
'                   2 = CGA
'                   11, 12 = MCGA, VGA
'      DENS      densita` di stampa (solo per CGA):
'                   1 = densita` singola (piu` veloce, meno precisa)
'                   2 = densita` doppia (meno veloce, piu` precisa)
'      F         buffer a cui inviare i valori
'
' ------------------------------------------------------------------------------
SUB FCOPY (SCR, DENS, F)

   SELECT CASE SCR
      CASE 2
         DEF SEG = &HB800
         PRINT #F, CHR$(27); CHR$(51); CHR$(24);
         IF DENS = 2 THEN
            C$ = CHR$(27) + CHR$(76) + CHR$(32) + CHR$(3)
         ELSE
            C$ = CHR$(27) + CHR$(75) + CHR$(144) + CHR$(1)
         END IF
         FOR M = 0 TO 79
            PRINT #F, C$;
            FOR L = 7920 TO 0 STEP -80
               P = M + L
               P1$ = CHR$(PEEK(P + 8192))
               P2$ = CHR$(PEEK(P))
               IF P1$ = CHR$(26) THEN P1$ = CHR$(24) ' per evitare ^Z = fine file
               IF P2$ = CHR$(26) THEN P2$ = CHR$(24) ' per evitare ^Z = fine file
               IF DENS = 2 THEN
                  PRINT #F, P1$; P1$; P1$; P1$; P2$; P2$; P2$; P2$;
               ELSE
                  PRINT #F, P1$; P1$; P2$; P2$;
               END IF
            NEXT L
            PRINT #F,
         NEXT M
         PRINT #F, CHR$(27); CHR$(51); CHR$(36);
      CASE 11, 12
         DEF SEG = &HA000
         PRINT #F, CHR$(27); CHR$(51); CHR$(24);
         C$ = CHR$(27) + CHR$(75) + CHR$(224) + CHR$(1)
         FOR M = 0 TO 79
            PRINT #F, C$;
            FOR L = 38320 TO 0 STEP -80
               CH$ = CHR$(PEEK(M + L))
               IF CH$ = CHR$(26) THEN CH$ = CHR$(24) ' per evitare ^Z = fine file
               PRINT #F, CH$;
            NEXT L
            PRINT #F,
         NEXT M
         WIDTH "LPT1:", 80
         PRINT #F, CHR$(27); CHR$(51); CHR$(36);
      CASE ELSE
         ' attualmente non previsto
   END SELECT

END SUB

' ================================ LCOPY =======================================
'
'   Effettua la copia dello schermo, in modalita` grafica, sulla stampante
'
'   Variabili di ingresso:
'      SCR       modalita` grafica corrente; sono previste:
'                   2 = CGA
'                   11, 12 = MCGA, VGA
'      DENS      densita` di stampa (solo per CGA):
'                   1 = densita` singola (piu` veloce, meno precisa)
'                   2 = densita` doppia (meno veloce, piu` precisa)
'
' ------------------------------------------------------------------------------
SUB LCOPY (SCR, DENS)

   SELECT CASE SCR
      CASE 2
         DEF SEG = &HB800
         LPRINT CHR$(27); CHR$(51); CHR$(24);
         WIDTH "LPT1:", 255
         IF DENS = 2 THEN
            C$ = CHR$(27) + CHR$(76) + CHR$(32) + CHR$(3)
         ELSE
            C$ = CHR$(27) + CHR$(75) + CHR$(144) + CHR$(1)
         END IF
         FOR M = 0 TO 79
            LPRINT C$;
            FOR L = 7920 TO 0 STEP -80
               P = M + L
               P1$ = CHR$(PEEK(P + 8192))
               P2$ = CHR$(PEEK(P))
               IF DENS = 2 THEN
                  LPRINT P1$; P1$; P1$; P1$; P2$; P2$; P2$; P2$;
               ELSE
                  LPRINT P1$; P1$; P2$; P2$;
               END IF
            NEXT L
            LPRINT
         NEXT M
         WIDTH "LPT1:", 80
         LPRINT CHR$(27); CHR$(51); CHR$(36);
      CASE 11, 12
         DEF SEG = &HA000
         LPRINT CHR$(27); CHR$(51); CHR$(24);
         WIDTH "LPT1:", 255
         C$ = CHR$(27) + CHR$(75) + CHR$(224) + CHR$(1)
         FOR M = 0 TO 79
            LPRINT C$;
            FOR L = 38320 TO 0 STEP -80
               LPRINT CHR$(PEEK(M + L));
            NEXT L
            LPRINT
         NEXT M
         WIDTH "LPT1:", 80
         LPRINT CHR$(27); CHR$(51); CHR$(36);
      CASE ELSE
         ' attualmente non previsto
   END SELECT

END SUB

' ================================ ModGraf =====================================
'
'   Individua la scheda grafica presente
'
'   Variabili di uscita:
'      Scheda    modalita` grafica caratteristica della scheda;
'                si prova nell'ordine:
'                   12 = VGA
'                   11 = MCGA
'                    8 = EGA
'                    2 = CGA
'                    3 = Hercules
'                    0 = possibile solo modalita` testo
'
' ------------------------------------------------------------------------------
SUB ModGraf (Scheda)

   Scheda1 = VGA
   ON ERROR GOTO ModGrafErr
   SCREEN Scheda1
   ON ERROR GOTO 0
   Scheda = Scheda1

END SUB

