'                                 RIPART.BAS

'     versione 1.3 per QBASIC                                  rev. 02.94

DECLARE SUB Ripartizione (Fi$, Fo$, Unit!)

CONST SisTec = 0, SisInt = 1

CLS
PRINT "                  RIPART - vers. 1.3                 rev. 02.94"
PRINT : PRINT
PRINT "        Le ipotesi  di calcolo  e le  modalit  operative  del  programma"
PRINT "        RIPART sono riportate nella terza parte,  capitolo 6,  del libro:"
PRINT "        A.Ghersi, Edifici antisismici con struttura intelaiate in cemento"
PRINT "        armato, CUEN, Napoli, 1986-1991."
PRINT
PRINT "        La presente versione legge i dati da un file anzich da linee del"
PRINT "        programma;  inoltre,  in aggiunta  a quanto  indicato  nel libro,"
PRINT "        consente di mandare in esecuzione il programma con l'opzione:"
PRINT "           /SI    se dati  e risultati  sono  nel sistema  internazionale"
PRINT "                    (unit base kN e m)"
PRINT
PRINT
PRINT "        Nome del file che contiene i dati ";
INPUT Fi$
PRINT
PRINT "        Unit di uscita ?"
PRINT "        CON=schermo, PRN=stampante, oppure nome di un file"
PRINT "        ";
INPUT Fo$
Fo$ = UCASE$(Fo$)
IF Fo$ = "" THEN Fo$ = "CON"
PRINT
C$ = UCASE$(COMMAND$)
IF INSTR(C$, "/SI") <> 0 THEN Unit = SisInt ELSE Unit = SisTec
CALL Ripartizione(Fi$, Fo$, Unit)
END

SUB Ripartizione (Fi$, Fo$, Unit)
 
   IF Unit = SisInt THEN
      For$ = "kN"
      Mom$ = "kNm"
   ELSEIF Unit = SisTec THEN
      For$ = "t "
      Mom$ = "tm "
   END IF
   ' - - - - -  dimensionamento variabili con indice
   DIM D1(20), D2(20), K1(20), K2(20)
   ' - - - - -  apertura dei file
   Fi = FREEFILE
   OPEN Fi$ FOR INPUT AS #Fi
   Fo = FREEFILE
   OPEN Fo$ FOR OUTPUT AS #Fo
   ' - - - - -  lettura dati generali
   INPUT #Fi, N, M, P
   Dmin = 10000
   Dmax = -10000
   FOR I = 1 TO N
      INPUT #Fi, D1(I)
      IF D1(I) < Dmin THEN Dmin = D1(I)
      IF D1(I) > Dmax THEN Dmax = D1(I)
   NEXT I
   DD1 = Dmax - Dmin
   Dmin = 10000
   Dmax = -10000
   FOR J = 1 TO M
      INPUT #Fi, D2(J)
      IF D2(J) < Dmin THEN Dmin = D2(J)
      IF D2(J) > Dmax THEN Dmax = D2(J)
   NEXT J
   DD2 = Dmax - Dmin
   Q = 0: X0 = 0: Y0 = 0
   FOR K = P TO 1 STEP -1
      ' - - - - -  lettura dati di piano
      FOR I = 1 TO N
         INPUT #Fi, K1(I)
      NEXT I
      FOR J = 1 TO M
         INPUT #Fi, K2(J)
      NEXT J
      INPUT #Fi, F, X, Y
      ' - - - - -  calcolo taglio globale di piano
      X0 = (Q * X0 + F * X) / (Q + F)
      Y0 = (Q * Y0 + F * Y) / (Q + F)
      Q = Q + F
      ' - - - - -  telai in direzione x
      S1 = 0: V = 0: I1 = 0
      FOR I = 1 TO N
         S1 = S1 + K1(I)
         V = V + K1(I) * D1(I)
      NEXT I
      Y1 = V / S1
      FOR I = 1 TO N
         I1 = I1 + K1(I) * (D1(I) - Y1) ^ 2
      NEXT I
      ' - - - - -  telai in direzione y
      S2 = 0: V = 0: I2 = 0
      FOR J = 1 TO M
         S2 = S2 + K2(J)
         V = V + K2(J) * D2(J)
      NEXT J
      X1 = V / S2
      FOR J = 1 TO M
         I2 = I2 + K2(J) * (D2(J) - X1) ^ 2
      NEXT J
      ' - - - - -  stampa risultati
      PRINT #Fo, "    PIANO "; K
      PRINT #Fo, : PRINT #Fo,
      PRINT #Fo, USING "    forza  ####.## \\     posizione :      x  = ##.## m      y  = ##.## m"; F; For$; X; Y
      PRINT #Fo,
      PRINT #Fo, USING "    taglio ####.## \\     posizione :      xQ = ##.## m      yQ = ##.## m"; Q; For$; X0; Y0
      PRINT #Fo,
      PRINT #Fo, USING "    baricentro rigidezze :                 xG = ##.## m      yG = ##.## m"; X1; Y1
      PRINT #Fo,
      PRINT #Fo, USING "    somma e momento d'inerzia rigidezze :  #####.##   #####.##   #####.##"; S1; S2; I1 + I2
      rkx = SQR((I1 + I2) / S1)
      rky = SQR((I1 + I2) / S2)
      ex = Y0 - Y1
      ey = X0 - X1
      '
      PRINT #Fo, : PRINT #Fo, : PRINT #Fo, "             FORZE IN DIREZIONE X"
      PRINT #Fo,
      PRINT #Fo, USING "    eccentricit :                         ex = ##.## m      Ex = ##.####"; ex; ex / DD1
      PRINT #Fo, USING "    raggio d'inerzia delle rigidezze :    rkx = ##.## m     Rkx = ##.####"; rkx; rkx / DD1
      Q1 = Q: Q2 = 0: GOSUB 800
      '
      PRINT #Fo, : PRINT #Fo, : PRINT #Fo, "             FORZE IN DIREZIONE Y"
      PRINT #Fo,
      PRINT #Fo, USING "    eccentricit :                         ey = ##.## m      Ey = ##.####"; ey; ey / DD2
      PRINT #Fo, USING "    raggio d'inerzia delle rigidezze :    rky = ##.## m     Rky = ##.####"; rky; rky / DD2
      Q1 = 0: Q2 = Q: GOSUB 800
      '
      PRINT #Fo, : PRINT #Fo, : PRINT #Fo,
   NEXT K
   CLOSE #Fi
   CLOSE #Fo
   LOCATE 23, 1
   PRINT "Elaborazione terminata"
   EXIT SUB
   '
   ' ---------  calcola e stampa valori per i telai
800
   M0 = Q1 * (Y0 - Y1) - Q2 * (X0 - X1)
   PRINT #Fo,
   PRINT #Fo, USING "    Qx =####.## \\      Qy =####.## \\      M =#####.## \ \"; Q1; For$; Q2; For$; M0; Mom$
   PRINT #Fo, : PRINT #Fo, "      TELAI PARALLELI ALL'ASSE X"
   PRINT #Fo, "    telaio      ordinata     rigidezza     taglio"
   FOR I = 1 TO N
      V1 = Q1 * K1(I) / S1: V2 = M0 * K1(I) * (D1(I) - Y1) / (I1 + I2)
      PRINT #Fo, USING "     ###       ####.## m    #####.##      ####.##  + ####.##   =####.## \\"; I; D1(I); K1(I); V1; V2; V1 + V2; For$
   NEXT I
   PRINT #Fo, : PRINT #Fo, "      TELAI PARALLELI ALL'ASSE Y"
   PRINT #Fo, "    telaio       ascissa     rigidezza     taglio"
   FOR J = 1 TO M
      V1 = Q2 * K2(J) / S2: V2 = -M0 * K2(J) * (D2(J) - X1) / (I1 + I2)
      PRINT #Fo, USING "     ###       ####.## m    #####.##      ####.##  + ####.##   =####.## \\"; J; D2(J); K2(J); V1; V2; V1 + V2; For$
   NEXT J
RETURN

END SUB

