DECLARE FUNCTION tel$ (J!, JX!)

CLS
PRINT "                  TESPA - vers. 1.2                  rev. 02.91"
PRINT : PRINT
PRINT "        Le ipotesi  di calcolo  e le  modalita`  operative  del programma"
PRINT "        TESPA  sono riportate nella terza parte,  capitolo 7,  del libro:"
PRINT "        A.Ghersi, Edifici antisismici con struttura intelaiate in cemento"
PRINT "        armato, CUEN, Napoli, 1988."
PRINT
PRINT "        La presente versione,  in aggiunta  a quanto indicato  nel libro,"
PRINT "        consente  di mandare in esecuzione  il programma  con le seguenti"
PRINT "        opzioni:"
PRINT "           /I     se dati e risultati  sono nel sistema internazionale"
PRINT "                    (unita` base kN e m, per il modulo elastico N/mm)"
PRINT "           /C     per far stampare  i dati man mano  che vengono letti"
PRINT "                    (utile per individuare  eventuali errori di input)"
PRINT : PRINT
'
C$ = COMMAND$
IF INSTR(C$, "/I") = 0 THEN STecn = 1 ELSE STecn = 0
Contr = INSTR(C$, "/C")
IF STecn THEN SqAm = .0005 ELSE SqAm = .005

10  OPTION BASE 1 '   definisce l'estremo inferiore dell'indice degli array
20  MI = 160: MJ = 40: MK = 7: ML = 50
30  DIM IR(MJ), MR(MJ)
40  DIM DL(MI - 1), DT(MJ), H(MK), NP(MI), ZB(ML), ZH(ML), ZI(ML)
50  DIM NT(MI - 1, MK), NR(MI, MK), WT(MI - 1, MK), WR(MI, MK), WN(MI, MK)
60  DIM XG(MK), YG(MK), WX(MK), WY(MK), WF(MK)
70  DIM Q(MI - 1, MK), MN(MI, MK), SM(MI, MK)
75  DIM XF(MK), YF(MK), FX(MK), FY(MK), FM(MK), QX(MK), QY(MK), QM(MK)
80  DIM DG(MJ, MK), FI(MI, MK), DX(MK), DY(MK), DF(MK), D(MJ, MK)
85  DIM MS(MI - 1, MK), MD(MI - 1, MK), MT(MI, MK), MP(MI, MK)
90  DIM TS(MI - 1, MK), TD(MI - 1, MK), TR(MI, MK), SN(MI, MK)
95  '
210 GOSUB 500  '      definisce unita` di ingresso e uscita
220 OPEN "I", #1, FI$
230 OPEN "O", #2, FO$
240 GOSUB 1000 '      legge dati geometrici
250 GOSUB 2000 '      stampa dati geometrici
260 GOSUB 3000 '      calcola indici di rigidezza e loro somma
270 WHILE NOT EOF(1)
280    INPUT #1, IV, IM, IO
290    GOSUB 4000 '   legge i carichi
300    GOSUB 5000 '   stampa i carichi
310    GOSUB 6000 '   calcola somma mom.inc. e somma forze
320    GOSUB 7000 '   effettua la risoluzione iterativa del sistema
330    GOSUB 8000 '   calcola momento, taglio, sforzo normale e spostamento
340    GOSUB 9000 '   stampa i risultati
350 WEND
360 CLOSE #1
370 CLOSE #2
390 LOCATE 24, 1
400 PRINT "FINE ELABORAZIONE"
410 END
480  '
490  '  ----- definisce le unita` di ingresso e uscita
500  PRINT "        Nome del file che contiene i dati ";
510  INPUT FI$
520  PRINT
530  PRINT "        Unita` di uscita ?"
540  PRINT "        CON=schermo, PRN=stampante, oppure nome di un file"
550  PRINT "        ";
560  INPUT FO$
     IF FO$ = "" THEN FO$ = "CON"
570  PRINT
580  RETURN
980  '
990  '  ----- effettua l'input dei dati geometrici ed elastici
1000 INPUT #1, IT$, JX, JY, KZ, LZ
     IF Contr THEN
        PRINT #2, "intestazione: " + CHR$(34) + IT$ + CHR$(34)
        PRINT #2, "numero di telai paralleli all'asse x: "; JX
        PRINT #2, "numero di telai paralleli all'asse y: "; JY
        PRINT #2, "numero di piani: "; KZ
        PRINT #2, "numero di tipi di sezione: "; LZ
     END IF
     JZ = JX + JY
     IF JZ > MJ THEN PRINT "NUMERO ECCESSIVO DI TELAI": STOP
     IF KZ > MK THEN PRINT "NUMERO ECCESSIVO DI PIANI": STOP
     IF LZ > ML THEN PRINT "NUMERO ECCESSIVO DI TIPI DI SEZIONE": STOP
     '
     IF Contr THEN PRINT #2, "numerazione dei pilastri:"
     I = 0
     FOR J = 1 TO JZ
        IF Contr THEN PRINT #2, USING "telaio \  \:"; tel$(J, JX)
        IR(J) = I
        INPUT #1, N
        WHILE N <> 0
           IF I = MI THEN PRINT "NUMERO ECCESSIVO DI PILASTRI": STOP
           I = I + 1
           NP(I) = N
           IF Contr THEN PRINT #2, NP(I);
           INPUT #1, N
        WEND
        MR(J) = I - IR(J)
        IF Contr THEN
           PRINT #2,
           PRINT #2, "numero totale di pilastri del telaio: "; MR(J)
        END IF
     NEXT J
     IZ = I
     '
     IF Contr THEN PRINT #2, "altezza dei piani:"
     FOR K = KZ TO 1 STEP -1
        INPUT #1, H(K)
        IF Contr THEN PRINT #2, H(K);
     NEXT K
     IF Contr THEN PRINT #2,
     '
     IF Contr THEN PRINT #2, "distanza dei telai dall'asse al quale sono paralleli:"
     FOR J = 1 TO JZ
        INPUT #1, DT(J)
        IF Contr THEN
           PRINT #2, USING "telaio \  \: "; tel$(J, JX);
           PRINT #2, DT(J)
        END IF
     NEXT J
     '
     IF Contr THEN PRINT #2, "luce delle campate:"
     FOR J = 1 TO JZ
        IF Contr THEN PRINT #2, USING "telaio \  \:"; tel$(J, JX)
        FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
           INPUT #1, DL(I)
           IF Contr THEN PRINT #2, DL(I);
        NEXT I
        IF Contr THEN PRINT #2,
     NEXT J
     '
     INPUT #1, EL
     IF Contr THEN PRINT #2, "modulo di elasticita`: "; EL
     IF STecn THEN E = EL * 10 ELSE E = EL * 1000
     '
     IF Contr THEN PRINT #2, "tipi di sezione:"
     FOR L = 1 TO LZ
        INPUT #1, ZB(L), ZH(L)
        IF Contr THEN PRINT #2, ZB(L); ZH(L),
        ZI(L) = ZB(L) * ZH(L) ^ 3 / 12
     NEXT L
     IF Contr THEN PRINT #2,
     '
     ER = 0
     FOR K = KZ TO 1 STEP -1
        IF Contr THEN PRINT #2, "travi dell'impalcato "; K; ":"
        FOR J = 1 TO JZ
           IF Contr THEN PRINT #2, USING "telaio \  \:"; tel$(J, JX)
           FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
              INPUT #1, NT(I, K)
              IF Contr THEN PRINT #2, NT(I, K);
              IF NT(I, K) < 1 OR NT(I, K) > LZ THEN PRINT "TIPO DI SEZIONE INACCETTABILE PER LA  TRAVE"; I; K: ER = 1
           NEXT I
           IF Contr THEN PRINT #2,
        NEXT J
     NEXT K
     '
     FOR K = KZ TO 1 STEP -1
        IF Contr THEN PRINT #2, "ritti dell'interpiano "; K; ":"
        FOR J = 1 TO JZ
           IF Contr THEN PRINT #2, USING "telaio \  \:"; tel$(J, JX)
           FOR I = IR(J) + 1 TO IR(J) + MR(J)
              INPUT #1, NR(I, K)
              IF Contr THEN PRINT #2, NR(I, K);
              IF NR(I, K) < 1 OR NR(I, K) > LZ THEN PRINT "TIPO DI SEZIONE INACCETTABILE PER IL RITTO"; I; K: ER = 1
           NEXT I
           IF Contr THEN PRINT #2,
        NEXT J
     NEXT K
     IF Contr THEN PRINT #2, "------------------------------------------------------------"
     IF ER = 1 THEN STOP
     '
     RETURN
1980 '
1990 ' ----- stampa i dati geometrici ed elastici
2000 PRINT #2, "    "; IT$: PRINT #2, : PRINT #2, : PRINT #2,
2010 '
2020 PRINT #2, "    ALTEZZA DEI PIANI"
2030 PRINT #2, : PRINT #2, "    piano     altezza (m)": PRINT #2,
2040 FOR K = KZ TO 1 STEP -1
2050    PRINT #2, USING "    ###     #####.##"; K, H(K)
2060 NEXT K
2070 '
2080 PRINT #2, : PRINT #2, : PRINT #2,
2090 PRINT #2, "    POSIZIONE DEI TELAI": PRINT #2,
2100 V = 0: V$ = "X"
2110 PRINT #2, "    telaio        distanza dall'asse (m)": PRINT #2,
2120 FOR J = 1 TO JZ
2130    IF J = JX + 1 THEN V = JX: V$ = "Y": PRINT #2,
2140    PRINT #2, USING "    ### !          #####.##"; J - V, V$, DT(J)
2150 NEXT J
2160 '
2170 PRINT #2, : PRINT #2, : PRINT #2,
2180 PRINT #2, "    LUCI E SEZIONI DELLE TRAVI": PRINT #2,
2190 PRINT #2, "    telaio  campata  luce   piano  B    H   inerzia";
2200 IF KZ > 1 THEN PRINT #2, "  piano  B    H   inerzia";
2210 PRINT #2,
2220 PRINT #2, "                      (m)         (m)  (m)   (m^4) ";
2230 IF KZ > 1 THEN PRINT #2, "        (m)  (m)   (m^4) ";
2240 PRINT #2,
2250 V = 0: V$ = "x"
2260 FOR J = 1 TO JZ
2270    IF J = JX + 1 THEN V = JX: V$ = "y"
2280    PRINT #2,
2290    FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
2300       IF I = IR(J) + 1 THEN PRINT #2, USING "     ## !"; J - V, V$;  ELSE PRINT #2, "         ";
2310       PRINT #2, USING "  ### -### ##.## "; NP(I), NP(I + 1), DL(I);
2320       FOR K = KZ TO 1 STEP -1
2330          L = NT(I, K)
2340          IF (KZ - K) MOD 2 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "                          ";
2350          PRINT #2, USING "   ## ##.## #.## #.######"; K, ZB(L), ZH(L), ZI(L);
2360       NEXT K
2370       PRINT #2,
2380    NEXT I
2390 NEXT J
2400 '
2410 PRINT #2, : PRINT #2, : PRINT #2,
2420 PRINT #2, "    SEZIONI DEI PILASTRI": PRINT #2,
2430 PRINT #2, "    telaio  pilastro        piano  B    H   inerzia";
2440 IF KZ > 1 THEN PRINT #2, "  piano  B    H   inerzia";
2450 PRINT #2,
2460 PRINT #2, "                                  (m)  (m)   (m^4) ";
2470 IF KZ > 1 THEN PRINT #2, "        (m)  (m)   (m^4) ";
2480 PRINT #2,
2490 V = 0: V$ = "x"
2500 FOR J = 1 TO JZ
2510    IF J = JX + 1 THEN V = JX: V$ = "y"
2520    PRINT #2,
2530    FOR I = IR(J) + 1 TO IR(J) + MR(J)
2540       IF I = IR(J) + 1 THEN PRINT #2, USING "     ## !"; J - V, V$;  ELSE PRINT #2, "         ";
2550       PRINT #2, USING "     ###         "; NP(I);
2560       FOR K = KZ TO 1 STEP -1
2570          L = NR(I, K)
2580          IF (KZ - K) MOD 2 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "                          ";
2590          PRINT #2, USING "   ## ##.## #.## #.######"; K, ZB(L), ZH(L), ZI(L);
2600       NEXT K
2610       PRINT #2,
2620    NEXT I
2630 NEXT J
2640 '
2650 PRINT #2, : PRINT #2, : PRINT #2,
     IF STecn THEN
        PRINT #2, "    Modulo di elasticita` = "; EL; " kg/cm2"
     ELSE
        PRINT #2, "    Modulo di elasticita` = "; EL; " N/mm2 "
     END IF
2660 '
2670 RETURN
2970 '
2980 ' ----- calcola l'indice di rigidezza delle aste
2990 '       effettua la loro somma nei nodi e nel piano
3000 FOR K = 1 TO KZ
3010    FOR J = 1 TO JZ
3020       FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
3030          L = NT(I, K)
3040          WT(I, K) = E * ZI(L) / DL(I)
3050       NEXT I
3060    NEXT J
3070    FOR I = 1 TO IZ
3080       L = NR(I, K)
3090       WR(I, K) = E * ZI(L) / H(K)
3100    NEXT I
3110 NEXT K
3120 '
3130 FOR K = 1 TO KZ
3140    I = 0
3150    FOR J = 1 TO JZ
3160       FOR M = 1 TO MR(J)
3170          I = I + 1
3180          S = WR(I, K)
3190          IF M > 1 THEN S = S + WT(I - 1, K)
3200          IF M < MR(J) THEN S = S + WT(I, K)
3210          IF K < KZ THEN S = S + WR(I, K + 1)
3220          WN(I, K) = S
3230       NEXT M
3240    NEXT J
3250 NEXT K
3260 '
3270 FOR K = 1 TO KZ
3280    J1 = 1: J2 = JX
3290    GOSUB 3600 '         calcola baricentro delle rigidezze
3300    WX(K) = S: WF(K) = S2
3310    YG(K) = S1
3320    FOR J = J1 TO J2
3330       DG(J, K) = DT(J) - YG(K)
3340    NEXT J
3350    J1 = JX + 1: J2 = JZ
3360    GOSUB 3600 '         calcola baricentro delle rigidezze
3370    WY(K) = S: WF(K) = WF(K) + S2
3380    XG(K) = S1
3390    FOR J = J1 TO J2
3400       DG(J, K) = XG(K) - DT(J)
3410    NEXT J
3420 NEXT K
3430 '
3440 RETURN
3580 '
3590 ' calcola baricentro delle rigidezze
3600 S = 0: S1 = 0: S2 = 0
3610 H2 = 1 / H(K) ^ 2
3620 FOR J = J1 TO J2
3630    V = 0
3640    FOR I = IR(J) + 1 TO IR(J) + MR(J)
3650       V = V + WR(I, K) * H2
3660    NEXT I
3670    S = S + V
3680    S1 = S1 + V * DT(J)
3690    S2 = S2 + V * DT(J) ^ 2
3700 NEXT J
3710 IF S <> 0 THEN S1 = S1 / S'      S=0 se non esistono telai in una direzione
3720 S2 = S2 - S * S1 ^ 2
3730 RETURN
3970 '
3980 ' ----- effettua l'input dei carichi verticali, nodali ed orizzontali
3990 '       azzera i carichi che non legge
4000 IF Contr THEN PRINT #2, "------------------------------------------------------------"
     IF NOT (IV = 0) THEN
        FOR K = KZ TO 1 STEP -1
           IF Contr THEN PRINT #2, "carichi verticali sulle travi dell'impalcato "; K; ":"
           FOR J = 1 TO JZ
              IF Contr THEN PRINT #2, USING "telaio \  \:"; tel$(J, JX)
              FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
                 INPUT #1, Q(I, K)
                 IF Contr THEN PRINT #2, Q(I, K);
              NEXT I
              IF Contr THEN PRINT #2,
           NEXT J
        NEXT K
     ELSE
        '  azzera carichi verticali
        FOR K = 1 TO KZ
           FOR I = 1 TO IZ
              Q(I, K) = 0
           NEXT I
        NEXT K
     END IF
     '
     IF NOT (IM = 0) THEN
        FOR K = KZ TO 1 STEP -1
           IF Contr THEN PRINT #2, "momenti nei nodi delle travi dell'impalcato "; K; ":"
           FOR J = 1 TO JZ
              IF Contr THEN PRINT #2, USING "telaio \  \:"; tel$(J, JX)
              FOR I = IR(J) + 1 TO IR(J) + MR(J)
                 INPUT #1, MN(I, K)
                 IF Contr THEN PRINT #2, MN(I, K);
              NEXT I
              IF Contr THEN PRINT #2,
           NEXT J
        NEXT K
     ELSE
        '  azzera momenti nodali
        FOR K = 1 TO KZ
           FOR I = 1 TO IZ
              MN(I, K) = 0
           NEXT I
        NEXT K
     END IF
     '
     IF NOT (IO = 0) THEN
        FOR K = KZ TO 1 STEP -1
           INPUT #1, XF(K), YF(K), FX(K), FY(K), FM(K)
           IF Contr THEN
              PRINT #2, "forze orizzontali sull'impalcato "; K; ":"
              PRINT #2, "x ="; XF(K); "     y ="; YF(K);
              PRINT #2, "     Fx ="; FX(K); "     Fy ="; FY(K); "     M ="; FM(K)
           END IF
        NEXT K
     ELSE
        '  azzera carichi orizzontali
        FOR K = 1 TO KZ
           XF(K) = 0: YF(K) = 0
           FX(K) = 0: FY(K) = 0: FM(K) = 0
        NEXT K
     END IF
     '
     IF Contr THEN PRINT #2, "------------------------------------------------------------"
     RETURN
4980 '
4990 ' ------ stampa i valori del carico verticale, nodale, orizzontale
5000 PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2,
5010 PRINT #2, "    CARICHI"
5020 IF KZ > 4 THEN KV = 4 ELSE KV = KZ
5030 IF IV = 0 THEN 5300'     salta i carichi verticali
     IF STecn THEN
        A$ = "         (t/m) ": B$ = "   ##  ####.## "
     ELSE
        A$ = "         (kN/m)": B$ = "   ##  #####.# "
     END IF
5040 PRINT #2, : PRINT #2, : PRINT #2,
5050 PRINT #2, "    CARICHI VERTICALI": PRINT #2,
5060 PRINT #2, "    telaio   campata";
5070 FOR K = 1 TO KV
5080    PRINT #2, "  piano  carico";
5090 NEXT K
5100 PRINT #2, : PRINT #2, "                    ";
5110 FOR K = 1 TO KV
5120    PRINT #2, A$;
5130 NEXT K
5140 PRINT #2,
5150 V = 0: V$ = "x"
5160 FOR J = 1 TO JZ
5170    PRINT #2,
5180    IF J = JX + 1 THEN V = JX: V$ = "y"
5190    FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
5200       IF I = IR(J) + 1 THEN PRINT #2, USING "     ## !"; J - V, V$;  ELSE PRINT #2, "         ";
5210       PRINT #2, USING "  ### -### "; NP(I), NP(I + 1);
5220       FOR K = KZ TO 1 STEP -1
5230          IF (KZ - K) MOD 4 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "                    ";
5240          PRINT #2, USING B$; K, Q(I, K);
5250       NEXT K
5260       PRINT #2,
5270    NEXT I
5280 NEXT J
5290 '
5300 IF IM = 0 THEN 5600'     salta i carichi nodali
     IF STecn THEN
        A$ = "         (tm)  ": B$ = "   ##  ####.## "
     ELSE
        A$ = "         (kNm) ": B$ = "   ##  #####.# "
     END IF
5310 PRINT #2, : PRINT #2, : PRINT #2,
5320 PRINT #2, "    MOMENTI NEI NODI ": PRINT #2,
5330 PRINT #2, "    telaio  pilastro";
5340 FOR K = 1 TO KV
5350    PRINT #2, "  piano momento";
5360 NEXT K
5370 PRINT #2,
5380 PRINT #2, "                    ";
5390 FOR K = 1 TO KV
5400    PRINT #2, A$;
5410 NEXT K
5420 PRINT #2,
5430 V = 0: V$ = "x"
5440 FOR J = 1 TO JZ
5450    PRINT #2,
5460    IF J = JX + 1 THEN V = JX: V$ = "y"
5470    FOR I = IR(J) + 1 TO IR(J) + MR(J)
5480       IF I = IR(J) + 1 THEN PRINT #2, USING "     ## !"; J - V, V$;  ELSE PRINT #2, "         ";
5490       PRINT #2, USING "     ###   "; NP(I);
5500       FOR K = KZ TO 1 STEP -1
5510          IF (KZ - K) MOD 4 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "                    ";
5520          PRINT #2, USING B$; K, MN(I, K);
5530       NEXT K
5540       PRINT #2,
5550    NEXT I
5560 NEXT J
5590 '
5600 IF IO = 0 THEN 5700'     salta i carichi orizzontali
     IF STecn THEN
        A$ = "               (m)         (m)         (t)         (t)         (tm)"
        B$ = "     ####.##"
     ELSE
        A$ = "               (m)         (m)        (kN)        (kN)        (kNm)"
        B$ = "     #####.#"
     END IF
     PRINT #2, : PRINT #2, : PRINT #2,
     PRINT #2, "    FORZE ORIZZONTALI": PRINT #2,
     PRINT #2, "    piano       x           y          Fx          Fy           M"
     PRINT #2, A$
     PRINT #2,
     FOR K = KZ TO 1 STEP -1
        PRINT #2, USING "     ##     ####.##     ####.##"; K, XF(K), YF(K);
        PRINT #2, USING B$; FX(K), FY(K), FM(K)
     NEXT K
     '
5700 RETURN
5970 '
5980 ' ----- calcola somma momenti d'incastro perfetto e momenti nei nodi
5990 '       calcola somma forze
6000 FOR K = 1 TO KZ
6010    I = 0
6020    FOR J = 1 TO JZ
6030       SM(I + 1, K) = MN(I + 1, K)
6040       FOR M = 1 TO MR(J) - 1
6050          I = I + 1
6060          V = Q(I, K) * DL(I) ^ 2 / 12
6070          SM(I, K) = SM(I, K) + V
6080          SM(I + 1, K) = MN(I + 1, K) - V
6090       NEXT M
6100       I = I + 1
6110    NEXT J
6120 NEXT K
6130 '
6140 FOR K = 1 TO KZ
6150    QX(K) = FX(K): QY(K) = FY(K)
6160    QM(K) = FM(K) + FX(K) * (YF(K) - YG(K)) - FY(K) * (XF(K) - XG(K))
6170 NEXT K
6180 FOR K = KZ - 1 TO 1 STEP -1
6190    K1 = K + 1
6200    QX(K) = QX(K) + QX(K1)
6210    QY(K) = QY(K) + QY(K1)
6220    QM(K) = QM(K) + QM(K1) + QX(K1) * (YG(K1) - YG(K)) - QY(K1) * (XG(K1) - XG(K))
6230 NEXT K
6240 '
6250 RETURN
6980 '
6990 ' ----- effettua la risoluzione iterativa del sistema
7000 GOSUB 7200 '       azzera rotazioni e spostamenti
7010 SQ = 0
7020 FOR K = 1 TO KZ
7030    I = 0
7040    FOR J = 1 TO JZ
7050       FOR M = 1 TO MR(J)
7060          I = I + 1
7070          GOSUB 7400 '       operazione di nodo
7080       NEXT M
7090    NEXT J
7100    GOSUB 7600 '       operazione di piano
7110 NEXT K
7120 IF SQ <> 0 THEN 7010
7130 RETURN
7180 '
7190 ' azzera rotazioni e spostamenti
7200 FOR K = 1 TO KZ
7210    FOR I = 1 TO IZ
7220       FI(I, K) = 0
7230    NEXT I
7240    FOR J = 1 TO JZ
7250       D(J, K) = 0
7260    NEXT J
7270    DX(K) = 0: DY(K) = 0: DF(K) = 0
7280 NEXT K
7290 RETURN
7380 '
7390 ' operazione di nodo per il nodo I,K
7400 IF WN(I, K) = 0 THEN RETURN
7410 S = SM(I, K) + 6 * WR(I, K) * D(J, K) / H(K)
7420 IF K > 1 THEN S = S - 2 * WR(I, K) * FI(I, K - 1)
7430 IF K < KZ THEN S = S + 6 * WR(I, K + 1) * D(J, K + 1) / H(K + 1) - 2 * WR(I, K + 1) * FI(I, K + 1)
7440 IF M > 1 THEN S = S - 2 * WT(I - 1, K) * FI(I - 1, K)
7450 IF M < MR(J) THEN S = S - 2 * WT(I, K) * FI(I + 1, K)
7460 IF ABS(S - 4 * WN(I, K) * FI(I, K)) < SqAm THEN RETURN
7470 FI(I, K) = S / 4 / WN(I, K)
7480 SQ = 1
7490 RETURN
7580 '
7590 ' operazione di piano per il piano K
7600 S2 = 0
7610 J1 = 1: J2 = JX: GOSUB 7800'   somma
7620 S1 = QX(K) + 6 * S1 / H(K)
7630 IF ABS(S1 - 12 * WX(K) * DX(K)) > SqAm THEN DX(K) = S1 / 12 / WX(K): SQ = 1
7640 J1 = JX + 1: J2 = JZ: GOSUB 7800'   somma
7650 S1 = QY(K) + 6 * S1 / H(K)
7660 IF ABS(S1 - 12 * WY(K) * DY(K)) > SqAm THEN DY(K) = S1 / 12 / WY(K): SQ = 1
7670 S2 = QM(K) + 6 * S2 / H(K)
7680 IF ABS(S2 - 12 * WF(K) * DF(K)) > SqAm THEN DF(K) = S2 / 12 / WF(K): SQ = 1
7690 FOR J = 1 TO JX
7700    D(J, K) = DX(K) + DG(J, K) * DF(K)
7710 NEXT J
7720 FOR J = JX + 1 TO JZ
7730    D(J, K) = DY(K) + DG(J, K) * DF(K)
7740 NEXT J
7750 RETURN
7780 '
7790 ' somma
7800 S1 = 0
7810 FOR J = J1 TO J2
7820    S = 0
7830    FOR I = IR(J) + 1 TO IR(J) + MR(J)
7840       V = FI(I, K)
7850       IF K > 1 THEN V = V + FI(I, K - 1)
7860       S = S + V * WR(I, K)
7870    NEXT I
7880    S1 = S1 + S
7890    S2 = S2 + S * DG(J, K)
7900 NEXT J
7910 RETURN
7970 '
7980 ' ----- calcola momento flettente, taglio, sforzo normale, spostamenti
7990 '       utilizza le convenzioni di segno della Scienza delle Costruzioni
8000 FOR K = 1 TO KZ
8010    FOR J = 1 TO JZ
8020       FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
8030          V = Q(I, K) * DL(I) ^ 2 / 12
8040          MS(I, K) = (4 * FI(I, K) + 2 * FI(I + 1, K)) * WT(I, K) - V
8050          MD(I, K) = -((2 * FI(I, K) + 4 * FI(I + 1, K)) * WT(I, K) + V)
8060       NEXT I
8070       FOR I = IR(J) + 1 TO IR(J) + MR(J)
8080          IF K > 1 THEN V = FI(I, K - 1) ELSE V = 0
8090          MT(I, K) = -((4 * FI(I, K) + 2 * V - 6 * D(J, K) / H(K)) * WR(I, K))
8100          MP(I, K) = (2 * FI(I, K) + 4 * V - 6 * D(J, K) / H(K)) * WR(I, K)
8110       NEXT I
8120    NEXT J
8130 NEXT K
8140 FOR K = 1 TO KZ
8150    FOR J = 1 TO JZ
8160       FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
8170          V = Q(I, K) * DL(I) / 2
8180          TS(I, K) = V + (MD(I, K) - MS(I, K)) / DL(I)
8190          TD(I, K) = -V + (MD(I, K) - MS(I, K)) / DL(I)
8200       NEXT I
8210       FOR I = IR(J) + 1 TO IR(J) + MR(J)
8220          TR(I, K) = (MT(I, K) - MP(I, K)) / H(K)
8230       NEXT I
8240    NEXT J
8250 NEXT K
8260 FOR K = KZ TO 1 STEP -1
8270    I = 0
8280    FOR J = 1 TO JZ
8290       FOR M = 1 TO MR(J)
8300          I = I + 1
8310          V = 0
8320          IF M > 1 THEN V = V + TD(I - 1, K)
8330          IF M < MR(J) THEN V = V - TS(I, K)
8340          IF K < KZ THEN V = V + SN(I, K + 1)
8350          SN(I, K) = V
8360       NEXT M
8370    NEXT J
8380 NEXT K
8390 FOR K = 2 TO KZ
8400    FOR J = 1 TO JZ
8410       D(J, K) = D(J, K) + D(J, K - 1)
8420    NEXT J
8430 NEXT K
8440 RETURN
8980 '
8990 ' ----- stampa i risultati
9000 PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2,
9010 PRINT #2, "    RISULTATI"
9020 PRINT #2, : PRINT #2, : PRINT #2,
9030 PRINT #2, "    SPOSTAMENTO DEGLI IMPALCATI": PRINT #2,
9040 PRINT #2, "    telaio    impalcato      spostamento"
9050 PRINT #2, "                                (mm)"
9060 V = 0: V$ = "X"
9070 FOR J = 1 TO JZ
9080    IF J = JX + 1 THEN V = JX: V$ = "Y"
9090    PRINT #2,
9100    FOR K = KZ TO 1 STEP -1
9110       IF K = KZ THEN PRINT #2, USING "     ## !"; J - V, V$;  ELSE PRINT #2, "         ";
9120       PRINT #2, USING "        ##          ####.###"; K, D(J, K) * 1000
9130    NEXT K
9140 NEXT J
9150 '
     IF STecn THEN
        A$ = "                         sinistra (tm) destra (tm) sinistra (t)  destra (t)"
        B$ = "   ######.## "
        C$ = "                           sup.  (tm)   inf.  (tm)       (t)    normale (t)"
     ELSE
        A$ = "                         sinistra(kNm) destra(kNm) sinistra(kN)  destra(kN)"
        B$ = "   #######.# "
        C$ = "                           sup. (kNm)   inf. (kNm)      (kN)    normale(kN)"
     END IF
9160 PRINT #2, : PRINT #2, : PRINT #2,
9170 PRINT #2, "    CARATTERISTICHE DI SOLLECITAZIONE NELLE TRAVI": PRINT #2,
9180 PRINT #2, "    telaio campata piano   momento a    momento a    taglio a     taglio a"
9190 PRINT #2, A$
9200 V = 0: V$ = "x"
9210 FOR J = 1 TO JZ
9220    IF J = JX + 1 THEN V = JX: V$ = "y"
9230    FOR I = IR(J) + 1 TO IR(J) + MR(J) - 1
9240       PRINT #2,
9250       FOR K = KZ TO 1 STEP -1
9260          IF I = IR(J) + 1 AND K = KZ THEN PRINT #2, USING "    ### !"; J - V, V$;  ELSE PRINT #2, "         ";
9270          IF K = KZ THEN PRINT #2, USING " ### -###"; NP(I), NP(I + 1);  ELSE PRINT #2, "         ";
9280          PRINT #2, USING "  ##"; K;
9290          PRINT #2, USING B$; MS(I, K), MD(I, K), TS(I, K), TD(I, K)
9300       NEXT K
9310    NEXT I
9320 NEXT J
9330 '
9340 PRINT #2, : PRINT #2, : PRINT #2,
9350 PRINT #2, "    CARATTERISTICHE DI SOLLECITAZIONE NEI PILASTRI": PRINT #2,
9360 PRINT #2, "    telaio pilastro piano   momento      momento       taglio      sforzo"
9370 PRINT #2, C$
9380 V = 0: V$ = "x"
9390 FOR J = 1 TO JZ
9400    IF J = JX + 1 THEN V = JX: V$ = "y"
9410    FOR I = IR(J) + 1 TO IR(J) + MR(J)
9420       PRINT #2,
9430       FOR K = KZ TO 1 STEP -1
9440          IF I = IR(J) + 1 AND K = KZ THEN PRINT #2, USING "    ### !"; J - V, V$;  ELSE PRINT #2, "         ";
9450          IF K = KZ THEN PRINT #2, USING "    ###"; NP(I);  ELSE PRINT #2, "       ";
9460          PRINT #2, USING "    ##"; K;
9470          PRINT #2, USING B$; MT(I, K), MP(I, K), TR(I, K), SN(I, K)
9480       NEXT K
9490    NEXT I
9500 NEXT J
9510 '
9520 PRINT #2,
9530 PRINT #2, "    L'effettivo  sforzo normale  in ciascun pilastro  si ottiene  sommando"
9540 PRINT #2, "    il suo peso proprio,  lo scarico dei telai ortogonali  e gli eventuali"
9550 PRINT #2, "    carichi concentrati."
9560 PRINT #2, : PRINT #2,
9570 '
9580 RETURN

FUNCTION tel$ (J, JX)

   IF J <= JX THEN
      T$ = STR$(J) + " x"
   ELSE
      T$ = STR$(J - JX) + " y"
   END IF
   IF LEN(T$) > 4 THEN T$ = LTRIM$(T$)
   tel$ = T$
  
END FUNCTION

